%Program rysuje koo mohra dla podanych przez uytkownika wartoci napre
clear;
disp('Podaj naprenia wystpujce w PSN ')
Nx=input('Podaj naprenie normalne dziaajce w kierunku osi x ');
Ny=input('Podaj naprenie normalne dziaajce w kierunku osi y ');
Txy=input('Podaj naprenie styczne ');
disp('Promie koa Mohra wynosi:');
R=sqrt(((Nx-Ny)/2)^2+Txy^2) % wzr na promie koa mohra
disp('wsprzdna rodka koa Mohra')
s=(Nx+Ny)/2 
disp('Naprenia gwne')
N1=s+R 
N2=s-R
if Nx~=Ny  % warunek konieczny, w celu uniknicia dzielenia przez zero, ktre wystpuje dla Nx=Ny
m=2*Txy/(Nx-Ny); % wzory z wytrzymaoci materiaw
fi=atan(m);
if (Nx-Ny)*cos(fi)>0
    fi0=fi/pi*180; % poniewa funkcja atan() zwraca kt w radianach zamieniam go na stopnie
    fi01=fi0/2; 
    fi02=fi0/2+90;
elseif (Nx-Ny)*cos(fi)<0
    fi0=fi/pi*180;
    fi02=fi0/2;
    fi01=fi0/2-90;
end 
else
    fi01=45;
    fi02=-45;
end

disp('Kty okrelajce kierunki napre gwnych')
fi01
fi02
% Koo Mohra jest okrgiem o rodku (s,0) i promieniu R i parametrze t we wsp. biegunowych
t = linspace(0,2*pi,300); % tworz tablic o 300 elementach o wartociach rwnomiernie rozoonych pomidzy 0 i 2*pi 
x = s+R*cos(t); y = R*sin(t); % wsprzdne x i y zdefiniowame we wsprzdnych biegunowych
clf;
plot(x,y,'-','LineWidth',2); % rysuje koo Mohra
axis equal; % podziaka na obu osiach musi by taka sama, aby koo byo koem
hold on; % domylnie ustawione jest hold off, dziki ustawieniu hold on moemy na wykres zawierajcy koo nanosi inne elementy
z=N2-R; % w zalenoci od wartoci N2 ustalam lew granic wykresu
if N2>0
    z=-R;
end
w=N1+R; % w zalenoci od wartoci N1 ustalam praw granic wykresu
if N1<0
    w=R;
end
% osie ukadu lini cig na czarno
plot([z w], [0 0],'k-');
plot([0 0], [-2*R 2*R],'k-');
title('Koo Mohra')
xlabel('Naprenia normalne')
ylabel('Naprenia styczne')
axis tight; % wielko okna cile dopasowuje si do osi 
line([N2-100*(Nx-N2) N2 Nx N2+100*(Nx-N2)], [-100*Txy 0 Txy 100*Txy]);  % linie wskazujce kierunki napre gwnych
line([N2-100*(Ny-N2) N2 Ny N2+100*(Ny-N2)], [100*Txy 0 -Txy -100*Txy]);
% rodek okrgu - czerwona kropka
plot(s,0,'.','MarkerSize',15,'MarkerEdge','r');
text(s,0,'\bf O','VerticalAlignment','Top','HorizontalAlignment','Left'); % za pomoc \bf pogrubiam oznaczenie
plot(N2,0,'.','MarkerSize',15,'MarkerEdge','r');
text(N2,0,'\bf N2','VerticalAlignment','Top','HorizontalAlignment','Right'); % argument HorizontalAlingment pozwala na ustawienie pooenia tekstu wzgldem punktu
plot(N1,0,'.','MarkerSize',15,'MarkerEdge','r');
text(N1,0,'\bf N1','VerticalAlignment','Top','HorizontalAlignment','Left');
plot(Nx,0,'.','MarkerSize',15,'MarkerEdge','g');
text(Nx,0,'\bf Nx','VerticalAlignment','Bottom','HorizontalAlignment','Right');
plot(Ny,0,'.','MarkerSize',15,'MarkerEdge','g'); 
text(Ny,0,'\bf Ny','VerticalAlignment','Bottom','HorizontalAlignment','Left');
plot(Nx,Txy,'.','MarkerSize',15,'MarkerEdge','r');
plot(Ny,-Txy,'.','MarkerSize',15,'MarkerEdge','r');

text(w-(w-z)/30,0,'\bf N','VerticalAlignment','Bottom','HorizontalAlignment','Right');
text(0,2*R-R/20,'\bf t','VerticalAlignment','Top','HorizontalAlignment','Left');

if (abs(fi01)>45) & (abs(fi01)<135)   % w zalenoci od wartoci ktw obliczam odpowiednie pooenie oznaczenia dla prostych wskazujcych kierunek napre gwnych
   text(N2+(Nx-N2)*1.5*R/abs(Txy),1.5*R*Txy/abs(Txy),'\bf 1','VerticalAlignment','Top','HorizontalAlignment','Left');
   text(Ny+R/2,-Txy-Txy*R/(Ny-N2)/2,'\bf 2','VerticalAlignment','Top','HorizontalAlignment','Left');
else
   text(Nx+R/2,Txy+Txy*R/(Nx-N2)/2,'\bf 1','VerticalAlignment','Top','HorizontalAlignment','Left');
   text(N2+(Ny-N2)*1.5*R/abs(Txy),-1.5*R*Txy/abs(Txy),'\bf 2','VerticalAlignment','Top','HorizontalAlignment','Left');
end
grid
shg; % wykres jest wysuwany na wierzch
% Autor: K.Daszkiewicz
